package com.tofly.water.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.water.entity.ScadaStatusDuration;
import com.tofly.water.entity.dto.OverviewDto;
import com.tofly.water.entity.dto.ScadaStatusDurationDto;

import com.tofly.water.entity.dto.StatisticsRealDto;
import com.tofly.water.entity.vo.DeviceBusPumpsVo;
import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 记录设备运行时长状态(ScadaStatusDuration)表服务接口
 *
 * @author HaiQiu
 * @since 2022-12-26 16:37:24
 */
public interface ScadaStatusDurationService extends IService<ScadaStatusDuration> {

    /**
     * 根据ID查询
     *
     * @param id id
     * @return 数据
     */
    ScadaStatusDuration get(Serializable id);

    /**
     * 新增
     *
     * @param scadaStatusDurationDto 实体
     */
    void insert(ScadaStatusDurationDto scadaStatusDurationDto);

    /**
     * 修改
     *
     * @param scadaStatusDurationDto 实体
     */
    void edit(ScadaStatusDurationDto scadaStatusDurationDto);

    /**
     * 批量删除
     *
     * @param idList 数据ID集合
     */
    void delete(List<Long> idList);

    /**
     * 生成模板下载
     */
    void template();

    /**
     * 数据导入
     *
     * @param file 文件
     */
    void importData(MultipartFile file);

    /**
     * 分页查询
     *
     * @param page                分页
     * @param scadaStatusDuration 查询wrapper
     * @return 数据集合
     */
    Page<ScadaStatusDuration> pageList(Page page, ScadaStatusDuration scadaStatusDuration);

    /**
     * 数据导出
     *
     * @param page                分页
     * @param scadaStatusDuration 查询模型
     * @param isAll               是否导出全部数据，true是，false否（默认否）
     */
    void export(Page page, ScadaStatusDuration scadaStatusDuration, boolean isAll);

    /**
     * 查询所有数据
     *
     * @param scadaStatusDuration 查询条件
     * @return 查询所有数据
     */
    List<ScadaStatusDuration> allList(ScadaStatusDuration scadaStatusDuration);

    public void timingInsertData(Date start, Date end);


    Object statisticsReal(Page page, StatisticsRealDto dto);
}

